package com.braintree.customersupportbackoffice.handler;

import com.hybris.backoffice.editorarea.BackofficeEditorAreaLogicHandler;
import com.hybris.cockpitng.dataaccess.facades.object.exceptions.ObjectSavingException;
import com.hybris.cockpitng.engine.WidgetInstanceManager;
import com.hybris.cockpitng.util.notifications.NotificationService;
import com.hybris.cockpitng.util.notifications.event.NotificationEvent;
import de.hybris.platform.core.model.BraintreeGeneralConfigurationModel;
import de.hybris.platform.core.model.BraintreeVenmoConfigurationModel;

public class BraintreeVenmoConfigurationLogicHandler extends BackofficeEditorAreaLogicHandler {

    private static final String VENMO_CONFIGURATION_DISABLED = "venmoConfigurationDisabled";
    private static final String VENMO_ACCOUNT_LIMITATION_DISABLED = "venmoAccountLimitationDisabled";

    private NotificationService notificationService;

    @Override
    public Object performSave(WidgetInstanceManager widgetInstanceManager, Object currentObject) throws ObjectSavingException {
        BraintreeVenmoConfigurationModel braintreeVenmoConfigurationModel = (BraintreeVenmoConfigurationModel) currentObject;
        if (!braintreeVenmoConfigurationModel.isEnabled()) {
            notificationService.notifyUser(widgetInstanceManager, VENMO_CONFIGURATION_DISABLED,
                    NotificationEvent.Level.INFO);
        }
        return super.performSave(widgetInstanceManager, currentObject);
    }

    @Override
    public void beforeEditorAreaRender(WidgetInstanceManager widgetInstanceManager, Object currentObject) {
        BraintreeVenmoConfigurationModel braintreeVenmoConfigurationModel = (BraintreeVenmoConfigurationModel) currentObject;
        final BraintreeGeneralConfigurationModel generalConfigurationModel = braintreeVenmoConfigurationModel.getPluginConfiguration()
                .getBraintreeGeneralConfiguration();;
        if (!braintreeVenmoConfigurationModel.isEnabled()) {
            notificationService.notifyUser(widgetInstanceManager, VENMO_CONFIGURATION_DISABLED,
                    NotificationEvent.Level.WARNING);
        }
        if (generalConfigurationModel.isDropIn()) {
            notificationService.notifyUser(widgetInstanceManager, VENMO_ACCOUNT_LIMITATION_DISABLED,
                    NotificationEvent.Level.WARNING);
        }
        super.beforeEditorAreaRender(widgetInstanceManager, currentObject);
    }

    public void setNotificationService(NotificationService notificationService) {
        this.notificationService = notificationService;
    }
}
